proyecto/calc/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.index),
    path('sumar/<int:op1>/<int:op2>', views.add),
    path('restar/<int:op1>/<int:op2>', views.sub),
    path('multiplicar/<int:op1>/<int:op>', views.multi),
    path('dividir/<int:op1>/<int:op2>', views.div),
]

proyecto/cms/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.index),
    path('loggedIn', views.loggedIn),
    path('logout', views.logout_views),
    # se pone aqui para que no se ejecute la view de get
    # content ya que tambien es un string, y se
    # evaluan estas entradas atendiendo al orden.
    path('<str:llave>', views.get_content),
]

proyecto/proyecto/urls.py
from django.contrib import admin
from django.urls import include, path
from django.contrib.auth.views import LoginView as login

urlpatterns = [
    path('cms/', include('cms.urls')),
    path('calc/', include('calc.urls')),
    path('admin/', admin.site.urls),
    path('login', login.as_view(next_page='/cms/'))
]
            

proyecto/calc/models.py
from django.db import models

# Create your models here.

proyecto/cms/models.py
from django.db import models

class Contenido(models.Model):
    clave = models.CharField(max_length=64)
    valor = models.TextField()

    def __str__(self):
        return self.clave
        
    def tiene_as(self):
        return ('a' in self.valor)

class Comentario(models.Model):
    contenido = models.ForeignKey(Contenido, on_delete=models.CASCADE)
    titulo = models.CharField(max_length=200)
    cuerpo = models.TextField(blank=False)
    fecha = models.DateTimeField('publicado')
    
    def __str__(self):
        return self.titulo
        
    def tiene_as(self):
        return ('a' in self.titulo)

proyecto/calc/views.py
from django.http import HttpResponse


def index(request):
    return HttpResponse("Hola, mundo. Estás en la página de inicio de tu app llamada calc.")

def add(request, op1, op2):
    return HttpResponse(op1+op2)

def sub(request, op1, op2):
    return HttpResponse(op1-op2)

def multi(request, op1, op2):
    return HttpResponse(op1*op2)

def div(request, op1, op2):
    try:
        result = op1/op2
    except ZeroDivisionError:
        result = "No division by zero allowed!"
    return HttpResponse(result)

proyecto/cms/views.py
from django.http import HttpResponse
from django.shortcuts import get_object_or_404, render
from django.views.decorators.csrf import csrf_exempt
from django.utils import timezone
from django.contrib.auth import logout
from django.shortcuts import redirect
from django.template import loader

from .models import Contenido, Comentario
@csrf_exempt
def get_content(request, llave):
    if request.user.is_authenticated:
        if request.method == "PUT":
            valor = request.body.decode('utf-8')
        elif request.method == "POST":
            action = request.POST['action']
            if action == "Enviar Contenido":
                valor = request.POST['valor']
        if request.method == "PUT" or (request.method == "POST" and action == "Enviar Contenido"):
            try:
                c = Contenido.objects.get(clave=llave)
                c.valor = valor
            except Contenido.DoesNotExist:
                c = Contenido(clave=llave, valor=valor)
            c.save()
        if request.method == "POST" and action == "Enviar Comentario":
            c = Contenido.objects.get(clave=llave)
            titulo = request.POST['titulo']
            cuerpo = request.POST['cuerpo']
            q = Comentario(contenido=c, titulo=titulo, cuerpo=cuerpo, fecha=timezone.now())
            q.save()
    contenido = get_object_or_404(Contenido, clave=llave)
    return render(request, 'cms/content.html', {'contenido':contenido})


def index(request):
    content_list = Contenido.objects.all()
    context = {'content_list': content_list}
    return render(request, 'cms/index.html', context)


def loggedIn(request): # Esta funcion comprueba si hay una sesion abierta 
    if request.user.is_authenticated:
        logged = "Logged in as " + request.user.username
    else:
        logged = "Not logged in. <a href='/login'>Login via admin</a>"
    return HttpResponse(logged)


def logout_views(request): # esto sirve para que se desregistre una persona
    logout(request)
    return redirect("/cms/")

proyecto/cms/templates/cms/content.html
<h3>{{ contenido.valor }}</h3>
{% for comentario in contenido.comentario_set.all %}
    <hr>
    <h4>{{ comentario.titulo }}</h4><br>
        {{ comentario.cuerpo }}<br>
        Enviado el {{ comentario.fecha }}<br>
{% endfor %}

<hr>
<br>
{% if request.user.is_authenticated %}
    <form action="" method="POST">
      Introduce el (nuevo) contenido para esta página:
      <input type="text" name="valor">
      <input type="submit" name="action" value="Enviar Contenido">
    </form>

    <br>
    <form action="" method="POST">
      Introduce un nuevo comentario para esta página:
      <br>Título: <input type="text" name="titulo">
      <br>Cuerpo: <input type="text" name="cuerpo">
      <input type="submit" name="action" value="Enviar Comentario">
    </form>
{% else %}
    No está usted autenticado. <a href="/login">Registresé.</a>
{% endif %}

proyecto/cms/templates/cms/index.html
{% if content_list %}
    <ul>
    {% for content in content_list %}
        <li><a href="/cms/{{ content.clave }}">{{ content.clave }}</a></li>
    {% endfor %}
    </ul>
{% else %}
    <p>No contents are available.</p>
{% endif %}